#!/usr/bin/env node
import { inc as m, prerelease as u } from "semver";
import { join as p } from "node:path";
import { execSync as n } from "node:child_process";
import g from "pinyin";
import { readFileSync as f, existsSync as y } from "node:fs";
import a from "chalk";
const h = process.cwd(), S = "/.dc/publish.json", w = "/package.json", b = ({ gitOriginName: o = "origin" }) => {
  try {
    const t = n('git log -1 --pretty=format:"%an"').toString().trim(), l = n('git log -1 --pretty=format:"%ae"').toString().trim(), c = n('git log -1 --pretty=format:"%s"').toString().trim(), e = n("git config user.name").toString().trim(), r = n("git config user.email").toString().trim(), s = n("git rev-parse --abbrev-ref HEAD").toString().trim();
    let i = "";
    try {
      i = n(`git config --get remote.${o}.url`).toString().trim();
    } catch {
      throw new Error(`git remote ${o} 不存在`);
    }
    return {
      lastCommitter: t,
      lastCommitterPinYin: g(t, {
        style: g.STYLE_NORMAL,
        heteronym: !1
      }).join(""),
      lastCommitEmail: l,
      lastCommitMsg: c,
      userName: e,
      userNamePinYin: g(e, {
        style: g.STYLE_NORMAL,
        heteronym: !1
      }).join(""),
      userEmail: r,
      branchName: s,
      remoteUrl: i
    };
  } catch (t) {
    throw console.error("Error fetching git information:", t), t;
  }
}, d = async (o) => {
  const t = f(p(h, w), "utf-8"), l = JSON.parse(t);
  let c = l.name, e = "", r;
  const { version: s } = l;
  if (["major", "minor", "patch"].includes(o))
    e = m(s, o), r = "latest";
  else if (["premajor", "preminor", "prepatch"].includes(o)) {
    const i = u(s);
    i ? (console.log(
      a.yellow("当前版本已经是预发布版本，将会在当前版本基础上进行发布")
    ), i.length === 1 && typeof i[0] == "number" ? e = m(s, "prerelease") : e = s.split("-")[0] + "-0") : e = m(s, o), r = "next";
  } else
    r = "alpha", e = m(s, "prerelease", r);
  if (!e)
    throw new Error("version is empty");
  return {
    name: c,
    version: e,
    tag: r
  };
}, N = () => {
  let o;
  const t = p(h, S);
  if (y(t)) {
    const l = f(t, "utf-8");
    o = JSON.parse(l);
  } else
    console.log(a.yellow("未找到配置文件，将使用默认配置"));
  return {
    gitOriginName: "origin",
    ...o || {}
  };
}, C = async (o) => {
  const { mode: t, type: l } = o, c = N(), e = b(c);
  console.log("mode:", t), console.log("type:", l), console.log("gitInfo:", e);
  const r = await d(l), { version: s } = r;
  if (console.log("npmInfo:", r), n(`npm version ${s} 1>&2`), t === "npm") {
    const { tag: i } = r;
    n(`npm publish --tag ${i} 1>&2`);
  } else if (t === "web") {
    const { webBuild: i } = c;
    i ? n(`${i} 1>&2`) : console.log(a.yellow("webBuild为空，不执行web构建"));
  }
  n(`git push ${c.gitOriginName} v${r.version} 1>&2`), n(`git push ${c.gitOriginName} ${e.branchName} 1>&2`), console.log(a.green("发布成功"));
};
export {
  C as handler
};
